#!/usr/local/bin/perl -w
use DBI;

####################################
#The user to the common database
$dbuser = 'compute_user';
$dbpwd = 'FeindexAw3';
$dbserver = 'mysql.research.pdx.edu';
$db = 'compute_procs';
$jobtable = 'remote_jobs';
$repos = '/vol/apps/temp/executioner';
# set the minimal size of the pool of files to be kept
# when set to 0 all files will be eventually erased
$minsize = 40;
#maximum of time the manager will take care of the data
#after this it will be all automatically deleted
$hardtimelimit = 40;
###################################
#Limit the time files can stay in the storage
#Maximum 365 days
$cronlim = '7';



sub hardclean
{
my $out = `ls -alt $repos`;
my @lines = split /^/,$out;

#print 'Hello '.`whoami`;
my $currdate = `date +%G%j`;
my($lastyear, $lastday) = $currdate =~ m/(\d\d\d\d)(\d\d\d)$/;
$lastday = int($lastday) - $cronlim;
if ($lastday lt 0){
	$lastday = 365 + $lastday;
	$lastyear -= 1;
}
my $counter = 0;
foreach (@lines){
	$line = $_;
#	if ($line =~/(\d\d\d\d)([\/,-])(\d\d)([\/,-])(\d\d)(.*)(\w\w\w\w\w\w)/m){
	if ($line =~/([A-Z,a-z,0-9,_,+]*)$/m){
		if ($line =~/\.daemon-log\.log/m)
		{	
			#skip the log
			#print $line."\n";
		} else {
		$counter = $counter + 1;
       		if ($counter >  $minsize){
       			$ldate = $1."/".$3."/".$5;
       			$name = $7;
       			$out = `date -d $ldate +%G%j`;
       			my($lyear, $lday) = $out =~ m/(\d\d\d\d)(\d\d\d)$/;
       			$lday = int($lday);
			print $lastday."  ".$lday."\n";
       			if ($lday lt $lastday){
       				print $lday."  ".$lyear." Days: Current record \n";
				my $path = $repos."/".$name;
				my $ch = `chmod -R 777 $path`;
       				my $out = `rm -rf $path`;
       			} elsif ($lyear lt $lastyear){
       				print $lday."  ".$lyear." Year: Current record \n";
				my $path = $repos."/".$name;
       				my $out = `rm -rf $path`;
       			}
		}
	}
       	}
}

my $dbh = DBI->connect("DBI:mysql:$db:$dbserver","$dbuser","$dbpwd");
my $query = "SELECT dlocation FROM $jobtable";
my $tabled=$dbh->prepare($query);
$tabled->execute;
my $dlocation;
$tabled->bind_columns(\$dlocation);
my (@results, $loc);
 while (@results = $tabled->fetchrow()){
	 $loc = $repos."/".$dlocation;
	if (! -d $loc){
		$query = "DELETE from $jobtable WHERE dlocation=\'$dlocation\'";
		my $res = $dbh->prepare($query);
		$res->execute();
	}	


 }
}


sub clean
{

my $ctime = `date`;
my $home = $ENV{'HOME'};

my $dbh = DBI->connect("DBI:mysql:$db:$dbserver","$dbuser","$dbpwd");

my $query =  "SELECT dlocation,submitdate,state FROM $jobtable";
my $table_data = $dbh->prepare($query);
$table_data->execute;
# assign fields to variables
my ($submitdate, $state, $dlocation);

$table_data->bind_columns(\$dlocation, \$submitdate, \$state);
my $currdate = `date +%G%j`;
my($lastyear, $lastday) = $currdate =~ m/(\d\d\d\d)(\d\d\d)$/;
$lastday = int($lastday) - $cronlim;
if ($lastday lt 0){
	$lastday = 365 + $lastday;
	$lastyear -= 1;
}
print "Limit: ".$cronlim."  ".$lastday."  ".$lastyear."\n";

my @results;
# output name list to the browser
while (@results = $table_data->fetchrow()) {
	my ($cyear, $cday) = `date -d '$submitdate' +%G%j` =~ m/(\d\d\d\d)(\d\d\d)$/;
	$cday = int($cday);
	print $cday."  ".$lastday."\n";
	if ($state == 0){
		if ($cday lt $lastday){
			print $cday."  ".$cyear." Current record \n";
			my $out = `rm -rf $home."/".$dlocation`;
			my $query =  "delete from $jobtable where dlocation=\'$dlocation\'";		
			my $result = $dbh->prepare($query);
			$result->execute;	
		} elsif ($cyear lt $lastyear){
			print $dlocation."\n";
			my $out = `rm -rf $home."/".$dlocation`;
                        my $query =  "delete from $jobtable where dlocation=\'$dlocation\'";
                        my $result = $dbh->prepare($query);
			$result->execute;	
		}
	}elsif( ($lastday-$cday) > $hardtimelimit) {
		 my $out = `rm -rf $repos."/".$dlocation`;
		 my $query =  "delete from $jobtable where dlocation=\'$dlocation\'";
		 my $result = $dbh->prepare($query);
		 $result->execute;
 	 }
}

}

sub remove
{

	my $path = shift;

my $dbh = DBI->connect("DBI:mysql:$db:$dbserver","$dbuser","$dbpwd");

my $query =  "SELECT dlocation FROM $jobtable";
my $table_data = $dbh->prepare($query);
$table_data->execute;
# assign fields to variables
my ($dlocation);

$table_data->bind_columns(\$dlocation);

my @results;
my $existence = 0;
# output name list to the browser
while (@results = $table_data->fetchrow()) {
	if ($dlocation eq $path){
		# invalid request - database must be cleaned before
		$existence = 1;
	} 
}

if ($existence < 1){
	#erase this directory with all its contents
	$path = $repos."/".$path;
	my $out = `rm -rf $path`;
}

$query = "DELETE FROM $jobtable WHERE dlocation=\'$path\'";
$result = $dbh->prepare($query);
$result->execute;

}
if (not $ARGV[0]) {
	print ("Missing parameters\n");
	exit(0);
} elsif($ARGV[0] eq "--init"){
	init();
	exit(0);
} elsif($ARGV[0] eq '--clean'){
        clean();
	exit(0);
} elsif($ARGV[0] eq '--hardclean'){
        hardclean();
	exit(0);
} elsif($ARGV[0] eq '--remove'){
        remove($ARGV[1]);
	exit(0);
}



