<?php

require "mysqlconnect.inc.php";

define("TIMEOUT", 60);
define("PORT", 8080);
define("MACHINE_TABLE", "remote_machines");
define("JOB_TABLE", "remote_jobs");
define("COMMAND_TABLE", "remote_commands");
$command = "";
$host = "";
$tp = "/vol/apps/temp/executioner";

error_reporting(E_ALL);



function sendall($machineid, $commandfile, $datafile, $location){

	lsend($machineid, $commandfile, $location);

	usleep(500000);

	lsend($machineid, $datafile, $location);
	
	usleep(500000); 

	execute($location, $machineid);

}

function localclean($directory){

        if(substr($directory,-1) == '/')
        {
                $directory = substr($directory,0,-1);
        }
        if(!file_exists($directory) || !is_dir($directory))
        {
                return FALSE;
        }elseif(!is_readable($directory))
        {
                return FALSE;
        }
        $handle = opendir($directory);
        while (FALSE !== ($item = readdir($handle))){
                print ("deleting  location: ".$item."\n");
                $delpath = $directory."/".$item;
                recursive_remove_directory($delpath);
        }
        return 0;
}

function recursive_remove_directory($directory, $empty=FALSE)
{
	global $host, $port,$timeout, $tp;
	// if the path has a slash at the end we remove it here
	if(substr($directory,-1) == '/')
	{
		$directory = substr($directory,0,-1);
	}

	// if the path is not valid or is not a directory ...
	if(!file_exists($directory) || !is_dir($directory))
	{
		// ... we return false and exit the function
		return FALSE;

	// ... if the path is not readable
	}elseif(!is_readable($directory))
	{
		// ... we return false and exit the function
		return FALSE;

	// ... else if the path is readable
	}else{

		// we open the directory
		$handle = opendir($directory);

		// and scan through the items inside
		while (FALSE !== ($item = readdir($handle)))
		{
			// if the filepointer is not the current directory
			// or the parent directory
			if($item != '.' && $item != '..')
			{
				// we build the new path to delete
				$path = $directory.'/'.$item;

				// if the new path is a directory
				if(is_dir($path)) 
				{
					// we call this function with the new path
					recursive_remove_directory($path);

				// if the new path is a file
				}else{
					// we remove the file
					unlink($path);
				}
			}
		}		
		// close the directory
		closedir($handle);

		// if the option to empty is not set to true
		if($empty == FALSE)
		{
			// try to delete the now empty directory
			if(!rmdir($directory))
			{
				// return false if not possible
				return FALSE;
			}
		}
		// return success
		return TRUE;
	}
}

function clean($mode){

	$host = "dextro.research.pdx.edu";	
	
	if (($sock = pfsockopen($host, PORT, $errno, $errstr, TIMEOUT))  === false){
        	echo "Clean: stream_socket_client() failed". "\n"; 
	        exit;          
	}               

	if ($mode < 1){
		fwrite($sock,"clean --clean\n");
	} else {
		fwrite($sock,"clean --hardclean\n");
	}
	//flush($sock);
        usleep(50000);

	return 0;
}

function remove($host,$dir){

        if (($sock = pfsockopen($host, PORT, $errno, $errstr, TIMEOUT))  === false){
                echo "Remove: stream_socket_client() failed". "\n";
                exit;
        }

        fwrite($sock,"clean --remove $dir\n");
        flush($sock);
        usleep(50000);

        return 0;
}

function lsend($host, $file, $location){

	$fname = $file;

	if (preg_match('/(.*)\/(.+)$/', $file, $matches)){
                $fname = $matches[2];
        }
	
	if (($sock = pfsockopen($host, PORT, $errno, $errstr, TIMEOUT))  === false){
        	echo "Lsend: stream_socket_client() failed:".PORT.", ".TIMEOUT.", ".$host."\n"; 
	        exit;          
	}               

	//stream_set_timeout($sock,60);
	stream_set_blocking($sock,0);

	if (!file_exists($location)){
		fwrite($sock,"mkdir $location \n");
	}
	$fp =  fopen($file,"r");
	print $fp."\n";
	fwrite($sock,"filename: $fname\n");
	flush($sock);
	usleep(50000);
	$size = filesize($file);
	fwrite($sock,"sendfile $size \n");
	flush($sock);
	print "ININT: ".$sock."\n";
	usleep(50000);
	#start the data transfer of the command file
	while(!feof($fp) && $fp != NULL)
	{
		$line = fgets($fp);
		usleep(50000);
		print".";
		if(fwrite($sock,$line) === FALSE){
			echo "Network Ressource not Available \n";
			exit;
		}
		flush($sock);
	}
	 usleep(5000);
	echo "\nSending  End\n";
	fwrite($sock,"***END***\n");
	flush($sock);
	fclose($fp);
	return 0;
}

function execute($parameters, $machine){
	$sock =  pfsockopen($machine, PORT, $errno, $errstr, TIMEOUT);
	fwrite($sock,"execute '".$parameters."'\n");
	flush($sock);

}

function llist($parameters, $machine){
	$socck =  pfsockopen($machine, 8080, $errno, $errstr, 30);
	fwrite($socck,"list '".$parameters."'\n");
	$contents  = fgets($socck, 4096);
	return $contents;
}

function lget($parameters, $machine){
	$tp = $GLOBALS['tp'];
	$i = 0;
	$returnname = "";
        if (($sock = pfsockopen($machine, 8080, $errno, $errstr, 30))  === false){
		echo "$machine 8080<br>";
                echo "Lget: stream_socket_client() failed". "\n";
                exit;
        }
	fwrite($sock,"get '".$parameters."'\n");
	while (!feof($sock))
	{
		$contents  = fgets($sock, 4096);
		if (strlen($contents) <= 0 && strlen($buffer) < $filesize){
			exit;
		} else {
			if (preg_match('/FileSending:\s(\S+)\s(\d*\n)/', $contents, $matches)){
				$filename = substr($matches[1], 2);
				if (preg_match('/(.+)\/(\S+)$/',$filename, $matches1)){
					mkdir($tp."/".$matches1[1]);	
				}

				$filesize = $matches[2];
				$buffer = "";
				$retpos = strlen($matches[0]);
				$outf = $tp."/".$filename;
				$returnname = $outf;
				$fp =  fopen($outf,"w");
				fwrite($fp, substr($contents, $retpos));
				$buffer .= substr($contents, $retpos);
			} elseif (preg_match('/(\.*)(\*\*\*END\*\*\*\n)/',$contents, $matches)) {
				if (strlen($contents) > 10)
				{
					$bu = substr($contents, 0, -10);
					$buffer .= $bu;
					fwrite($fp,$bu);
				}
		       		fclose($fp);
				return $returnname;
                                exit;
                        } else	{
				fputs($fp, $contents);
				$buffer .= $contents;
			}
			$i++;
		}
	}
	return $returnname;
	exit;
}

function retreiveAll($location, $localloc){

                $machinetable = MACHINE_TABLE;
                $jobtable = JOB_TABLE;
                $query = "SELECT remote_machines_id from $jobtable WHERE dlocation = '$location'";
                $machineid = mysql_fetch_assoc(mysql_query($query));
		$machineid = $machineid['remote_machines_id'];

		$query = "SELECT iplocation from $machinetable WHERE id = '$machineid'";
                $daemonhost = mysql_fetch_assoc(mysql_query($query));
		$daemonhost = $daemonhost['iplocation'];

		

	if (($sock = pfsockopen($daemonhost, PORT, $errno, $errstr, TIMEOUT))  === false){
        	echo "RetreiveAll: ".$location.", ".$machineid.", ".$daemonhost." stream_socket_client() failed". "\n";
        	return;
	}
	stream_set_timeout($sock,30);
	stream_set_blocking($sock,0);
	ob_implicit_flush();

	$files = array();
	$fp = "";
	$buffer = "";
	$filesize = 0;
	$i = 0;
	$files = 0;
	fwrite($sock,"retreive $location\n");
	while (!feof($sock))
	{
		$contents  = fgets($sock, 4096);
		if (strlen($contents) <= 0 && strlen($buffer) < $filesize){
			return;
		} else {
			if (preg_match('/FileSending:\s(\S+)\s(\d*\n)/', $contents, $matches)){
//				print "receiving file: ".$matches[1]."<br>\n";
				$filename = $matches[1];
				$filesize = $matches[2];
				$buffer = "";
				$retpos = strlen($matches[0]);
				#make the local dir
				if (!file_exists($localloc."/".$location)){
					mkdir($localloc."/".$location, 0777);
				}
				#the local output file
				$lloc = $localloc."/".$location."/".$filename;
//				print $lloc."<br>\n";
				$fp =  fopen($lloc,"w");
				fwrite($fp, substr($contents, $retpos));
				$buffer .= substr($contents, $retpos);
			} elseif (preg_match('/(\.*)(\*\*\*END\*\*\*\n)/',$contents, $matches)) {
				if (strlen($contents) > 10)
				{
					$bu = substr($contents, 0, -10);
					$buffer .= $bu;
					fwrite($fp,$bu);
				}
//				print "closing file: ".$matches[1]."<br>\n";
		       		fclose($fp);
			} elseif (preg_match('/(\.*)(\*\*\*DONE\*\*\*\n)/',$contents, $matches)) {
                                return;
                        } else	{
				if ($fp){
					fputs($fp, $contents);
				}
				$buffer .= $contents;
			}
			$i++;
		}
	}
	return;
}

function retreive($location){

	$files = array();
	$fp = "";
	$buffer = "";
	$filesize = 0;
	$i = 0;
	$files = 0;
	$sock =  pfsockopen($machine, 8080, $errno, $errstr, 30);
	stream_set_timeout($sock,60);
	stream_set_blocking($sock,0);
	sleep(1);
	fwrite($sock,"retreive $location\n");
	while (!feof($sock))
	{
		$contents  = fgets($sock, 4096);
			print "Saved: ".strlen($buffer)." File Length: ".$filesize." \n";
		if (strlen($contents) <= 0 && strlen($buffer) < $filesize){
			print strlen($buffer)."  ".$filesize." \n";
			exit;
		} else {
			if (preg_match('/FileSending:\s(\S+)\s(\d*\n)/', $contents, $matches)){
				print_r($matches);
				print $contents."\n";
				$filename = $matches[1];
				$filesize = $matches[2];
				$buffer = "";
				print "FIlename : ".$filename." Filesize: ".$filesize."\n";
				$retpos = strlen($matches[0]);
				print "Ret position: ".$retpos."\n";
				$fp =  fopen($filename,"w");
				fwrite($fp, substr($contents, $retpos));
				$buffer .= substr($contents, $retpos);
				print strlen($contents)." $i . \n";
			} elseif (preg_match('/(\.*)(\*\*\*END\*\*\*\n)/',$contents, $matches)) {
				print_r($matches);
				if (strlen($contents) > 10)
				{
					$bu = substr($contents, 0, -10);
					$buffer .= $bu;
					fwrite($fp,$bu);
				}
		       		fclose($fp);
				print "File ".$filename." done \n";
			} elseif (preg_match('/(\.*)(\*\*\*DONE\*\*\*\n)/',$contents, $matches)) {
                                exit;
                        } else	{
				fputs($fp, $contents);
				print "Receiving: ".strlen($contents)."  ".$i."\n";
				$buffer .= $contents;
			}
			$i++;
			print strlen($buffer)."\n";
		}
	}	
}
?>
<?


/******* send a command file on the remote machine to a particular location*********/
function fnSendComDataLoc($application, $command, $data, $pathId){

                //get the ssh connection to dedicated machine
                $machineip = getMchLoc(array('appname' => $application, 'state' => 2));
                $machinetable = MACHINE_TABLE;
                $jobtable = JOB_TABLE;
		$query = "SELECT id from $machinetable WHERE iplocation = '$machineip'";
		$machineid = mysql_fetch_assoc(mysql_query($query));


		#prepare MYsQL queries and stuff
		$date = date("D M j G:i:s T Y");
                $query = "SELECT id from $machinetable WHERE iplocation = '$machineip'";
                $result = mysql_fetch_assoc(mysql_query($query));
                $result = $result['id'];
                $comand = $GLOBALS['appstrings']['R']."./commands.txt >& ./output.txt";

                $query="INSERT INTO $jobtable SET appname='$application', dlocation='$pathId', clocation='$pathId', command='$comand', submitdate='$date', alivetime='0:0:0', state=1, remote_machines_id=$result";
                $result = mysql_query($query);

                //prepare the job to be run on the remote machine
                $query = "SELECT dlocation FROM $jobtable WHERE submitdate='$date'";
                $temp  = mysql_fetch_row(mysql_query($query));
                $temp = $temp[0];
		$GLOBALS['rkey'] = $temp;

		usleep(500000);
		lsend($machineip, $command, $pathId);
		usleep(500000);
		lsend($machineip, $data, $pathId);
		#execute the uploaded files
		usleep(500000);
		execute($date, $machineip);
		usleep(500000);
		return 1;


}


/******* send a data file and a command file on the remote machine*********/
function fnSendAllData($application, $data, $command){
        if(func_num_args()>=1){  // if there is at least one argument

		//get the ssh connection to dedicated machine
		$machineid = getMachLoc(array('appname' => $application, 'state' => 2));
		//create the temporary location on the remote machine
		$pathId = substr(uniqid("5555"),-5);
		
		$uploaddir = $GLOBALS['uploaddir'];
		$dsendfile = $uploaddir.$_FILES['uploadDFile']['name'];
		$csendfile = $uploaddir.$_FILES['uploadCFile']['name'];
		sendall($machineid, $dsendfile, $csendfile, $pathId);

		$machinetable = $GLOBALS['machinetable'];
		$jobtable = $GLOBALS['jobtable'];
		$commandtable = $GLOBALS['commandtable'];
		$date = date("D M j G:i:s T Y");

		//extract the command to be run from the command table
		$query = "SELECT * from $commandtable where softname='$application'";
		$result = mysql_fetch_assoc(mysql_query($query));
		$command = parseComDB($result['command'], $result['input_file'], $result['output_file'], $result['parameters']);
 		$dd = getMch($application);	
		//print($dd[0]."Hello <BR>");
		$query="INSERT INTO $jobtable SET appname='$application', dlocation='$pathId', clocation='$pathId', command='$command', submitdate='$date', alivetime='0:0:0', state=1, remote_machines_id=$dd[0]";
		$result = mysql_query($query);

		//prepare the job to be run on the remote machine
		$query = "SELECT dlocation FROM $jobtable WHERE submitdate='$date'";
		$temp  = mysql_fetch_row(mysql_query($query));
	        $temp = $temp[0];
		$GLOBALS['rkey'] = $temp;

		execute($date, $machineid);
		sleep(1);
		
        } else {die('No arguments passed');}  // stops if nothing is
}

/******* send a command file on the remote machine*********/
function fnSendComData($application, $command){
        if(func_num_args()>=1){  // if there is at least one argument

                //get the ssh connection to dedicated machine
                $machineid = getMachLoc(array('appname' => $application, 'state' => 2));
                //create the temporary location on the remote machine
                $pathId = substr(uniqid("5555"),-5);

		$uploaddir = $GLOBALS['uploaddir'];
                $sendfile = $uploaddir.$_FILES['uploadCFile']['name'];
		#send data to the machine
		lsend($machineid, $sendfile,pathId);

		#prepare MYsQL queries and stuff
                $machineip = $GLOBALS['ssh2host'];
                $machinetable = $GLOBALS['machinetable'];
                $jobtable = $GLOBALS['jobtable'];
                $date = date("H:i:s");
                $query = "SELECT id from $machinetable WHERE iplocation = '$machineip'";
                $result = mysql_fetch_assoc(mysql_query($query));
                $result = $result['id'];
                $command = $GLOBALS['appstrings']['R']."./commands.txt >& ./results";

                $query="INSERT INTO $jobtable SET appname='$application', dlocation='$pathId', clocation='$pathId', command='$command', submitdate='$date', alivetime='0:0:0', state=1, remote_machines_id=$result";
                $result = mysql_query($query);

                //prepare the job to be run on the remote machine
                $query = "SELECT dlocation FROM $jobtable WHERE submitdate='$date'";
                $temp  = mysql_fetch_row(mysql_query($query));
                $temp = $temp[0];
		$GLOBALS['rkey'] = $temp;

		#execute the uploaded files
		execute($date, $machineid);
        } else {die('No arguments passed');}  // stops if nothing is
}

/******* Return a single machine Id based on desired application and minimum load ********/
function getMch($application){
	$table = $GLOBALS['machinetable'];
	$query = "SELECT id, MIN(state) from $table WHERE availsoft like '%$application%'  GROUP BY id";
	$temp  = mysql_query($query);
	return mysql_fetch_row($temp);
}

/******* Generate a valid command from the remote_command table fields ********/
function parseComDB($application, $input, $output, $parameters){

	$command = $parameters;
	$command = substr_replace($command, $output, strpos($command, "O"), 1);
	$command = substr_replace($command, $input, strpos($command, "I"), 1);
	$command = substr_replace($command, $application, strpos($command, "C"), 1);
	return $command;

}

/******* Modify the path to the data file - set it to temp directory*********/
function parseComFile($file, $path){
	$fc = file($file);
	$pat = '/read\Wtable\W{n}/i';
	$pattern = '/(\w+)<-(\w+)\W\"[:print:]\"*/i';
	$replace = '/(\w+)<-(\w+)\W\"[:print:]\"*/i';
	foreach($fc as $line){
		print($line."<br>");
		preg_match($pat, $line, $matches, PREG_OFFSET_CAPTURE, 3);
		print_r($matches);
	}
}

/******* Clean a given process from DB and from the HDD ********/

function fnCleanSingle($id){
	$table = $GLOBALS['jobtable'];
	$query = "SELECT dlocation,remote_machines_id FROM $table WHERE id='$id'";
	$pathId = mysql_fetch_assoc(mysql_query($query));
	$machineid = $pathId['remote_machines_id'];
	$pathId = $pathId['dlocation'];

	$table = $GLOBALS['machinetable'];
	$query = "SELECT iplocation FROM $table WHERE id='$machineid'";
	$machineid = mysql_fetch_assoc(mysql_query($query));
	$machineid = $machineid['iplocation'];

	if (strlen($pathId) > 3 && strlen($machineid) >3 ){
		$table = $GLOBALS['jobtable'];
		$query = "DELETE FROM $table WHERE id='$id'";
		$result = mysql_query($query);
		remove ($machineid, $pathId);	
	}
}

/******* Clean a given process from DB and from the HDD ********/
function fnCleanAll(){
	$jobtable = $GLOBALS['jobtable'];
	$query = "SELECT id FROM $dbtable";
	$id = mysql_fetch_array(mysql_query($query), MYSQL_NUM);
	for ($r = 0; $r < count($id); $r++){
		fnCleanSingle($id);
	}
}

/******* check if the table exists *********/
function fnTableExists($TableName) {
	$database = $GLOBALS['database'];

	//Verifies that a MySQL table exists
	$bRetVal = FALSE;
	$query = "SHOW TABLES FROM $database";
	$result = mysql_query($query);

	while ($row=mysql_fetch_array($result)) {
		if ($row[0] ==  $TableName)
			$bRetVal = TRUE;
	}
	mysql_free_result($result);
	return ($bRetVal);
}


/******* check if the database exists *********/
function fnDatabaseExists($dbName) {
	$dbconnection = $GLOBALS['dbconnection'];

	//Verifies existence of a MySQL database
	$bRetVal = FALSE;
	$result = mysql_list_dbs($dbconnection);
	while ($row=mysql_fetch_array($result, MYSQL_NUM)) {
		if ($row[0] ==  $dbName)
			$bRetVal = TRUE;
	}
	mysql_free_result($result);
	return ($bRetVal);
}
  
/******* Generate random picture for the page ************/
function setPic(){

	srand((double)microtime()*1000000); 
	$handle = opendir('pics');
	$files = array();
	$n = 0;
	while (false !== ($file = readdir($handle))) {
		if (strlen($file) > 3)
			$files[$n++] = $file;
   	}
	$number = count ($files);
	$id = rand(0,$number-1);
	$path = "pics/".$files[$id];
	$GLOBALS['image'] = "<img width=150 height=250 src=\"".$path."\"/>";
}

/******* Get a socket to a host***********************/
function getSocketTo($host){
	if (($GLOBALS['daemonsock'] = pfsockopen($host, $GLOBALS['daemonsocket'], $errno, $errstr, $GLOBALS['socktimeout']))  === false){
		echo "GetSocket: stream_socket_client() failed". "\n";
	}
	return $GLOBALS['daemonsock'];
}



function extractFields($tablefields){
        $fields = implode(",", $tablefields);
        $fields = trim($fields);
        return $fields;
}

function parseinitfields($userdata){
	#$userdata = explode("\n", "$userdata");
	$fields = "";
	$n = 0;
	foreach($userdata as $data){
        	if ($n != 0){
                	$temp = explode(" ", $data);
	                if (strlen($temp[0]) > 0 & preg_match("/^`id`/", $temp[0], $matches, PREG_OFFSET_CAPTURE) < 1)
        	                $fields = $fields.$temp[0].",";
        	}
	        $n = $n+1;
	}
	return rtrim($fields, ",");
}
function getMchLoc($parameters){
	$app = $parameters['appname'];
	$state = $parameters['state'];
	$machinetable = MACHINE_TABLE;

	$query = "SELECT * from $machinetable WHERE state <= '$state' AND availsoft like '%$app%'";
	if (!($result = mysql_query($query)))
		print("Result from connection: ".$query);
	if ($assoc = mysql_fetch_assoc($result)){
		$id = $assoc['id'];
		$query = "SELECT iplocation from $machinetable WHERE id = $id";
		$res = mysql_fetch_assoc(mysql_query($query));
		return $res['iplocation'];	
	}
}

function getMachLoc($parameters){
	$app = $parameters['appname'];
	$state = $parameters['state'];
	$machinetable = $GLOBALS['machinetable'];

	$query = "SELECT * from $machinetable WHERE state <= '$state' AND availsoft like '%$app%'";
	if (!($result = mysql_query($query)))
		print("Result from connection: ".$query);
	if ($assoc = mysql_fetch_assoc($result)){
		$id = $assoc['id'];
		$query = "SELECT iplocation from $machinetable WHERE id = $id";
		$res = mysql_fetch_assoc(mysql_query($query));
		return $res['iplocation'];	
	}
}
?>
